package tools;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;

public class BreadthFirstIter<T> {
    public interface Expand<T> {
        public List<T> expand(T elem);
    }
    
    private BreadthFirstIter.Expand expand;
    private HashSet<T> visited = new HashSet<T>();
    private ArrayList<T> queue = new ArrayList<T>();

    public BreadthFirstIter(T start, BreadthFirstIter.Expand expand) {
        this.expand = expand;
        queue.add(start);
    }

    public boolean hasNext() {
        return !queue.isEmpty();
    }

    public T next() {
        T current = queue.remove(0);
        List<T> successors = expand.expand(current);

        for (T succ : successors) {
            if (!visited.contains(succ)) {
                queue.add(succ);
            }
        }
        visited.add(current);

        return current;
    }
}