package view;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**

 @author reidl
 */
public class PaintExample extends JFrame {

    public PaintExample(BoardPainter painter) {
        setSize(painter.getWidth()+50, painter.getHeight()+50);
        
        add(new BoardPanel(painter));
        
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setVisible(true);
    }

    private class BoardPanel extends JPanel {
        private BoardPainter painter;
        
        BoardPanel( BoardPainter painter ) {
            this.painter = painter;
        }

        @Override
        public Dimension getPreferredSize() {
            return new Dimension(painter.getWidth(), painter.getHeight());
        }

        @Override
        protected void paintComponent(Graphics g) {
            super.paintComponent(g);
            g.clearRect(0, 0, getWidth(), getHeight());
            painter.paint((Graphics2D)g);
        }
    }
}
